/*
 * Program:     Printset for Unix v1.0
 * Module:      MAIN (main)
 * Description: Main program block and curses event loop
 * Date:        3-March-95
 * Author:      Ian Chard
 *
 * Copyright (C) 1993-1995 ITC Ltd.  All rights reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETRY SOURCE CODE OF ITC LTD, AND MAY
 * NOT BE DISTRIBUTED, DUPLICATED OR MODIFIED WITHOUT THE WRITTEN
 * PERMISSION OF AN AUTHORISED REPRESENTATIVE OF HBM LTD.
 *
 */
 
static char sccsid[]="@(#)main.c	1.7 7/18/95 ITC";

#include <curses.h>
#include "sparkle.h"

char scratch_buffer[8192];
int current_row=-1;


int main(argc, argv)
	int argc;
	char *argv[];
{
	int i, done=0;

	catch_signals();

	if(argc!=1)
	{
		fprintf(stderr, "usage:  %s\n", argv[0]);
		return 1;
	}

	if(!UDPInit())
		return 1;

	AcquirePSList();
	display_init();
	draw_screen();

	while(!done)
	{
		while((i=getch())==-1)
		{
			AcquirePSList();
			display_list();
		}

		switch(i)
		{
			case 'j':
#ifdef KEY_DOWN
			case KEY_DOWN:
#endif

				if(current_row<NumberOfSummaries-1)
				{
					highlight_row(current_row+1);
					wrefresh(wList);
				}
				break;

			case 'k':
#ifdef KEY_UP
			case KEY_UP:
#endif

				if(current_row>0)
				{
					highlight_row(current_row-1);
					wrefresh(wList);
				}
				break;

#ifdef SPARKLE_AUTO_IP
			case 'a':

				if(current_row>=0)
				{
					auto_ip(SortedList[current_row]);
					draw_screen();
				}
				
				break;
#endif

#ifdef KEY_ENTER
			case KEY_ENTER:
#endif
			case '\n':

				if(current_row>=0)
				{
					if(SortedList[current_row]->ps.Address.s_addr==htonl(0x0b16212c))	/* 11.22.33.44 */
						auto_ip(SortedList[current_row]);
					else
						display_details(SortedList[current_row]);

					draw_screen();
				}
				break;

			case '\x0c':	/* ^L */

				draw_screen();
				break;

			case 'q':
			case 'Q':

				done=1;
				break;

			case '$':

				centre(LINES-1, "Refreshing list...");
				refresh();
				AcquirePSList();
				draw_screen();
				break;

			case -1:

				break;

#ifdef HAVE_BEEP
			default:
				beep();
#endif
		}
	}

	display_shutdown();

	return 0;
}
