/*
* FILE     : printset.h
* CREATED  : Wednesday, 2/2/1994
* AUTHOR   : Phil Beecher
* OWNER    : (C) Ringdale Ltd 1994
* SYSTEM   : Ansi C
* CONTENT  : definitions for the Printset Program
*          : 
* $Log:   C:/itc/printset/zinc/new/printset.h_v  $
*
*   Rev 1.3   14 Jul 1994 11:22:46
*First Release of pset and wpset for version 4 printservers
*
*
*
*   Rev 1.2   07 Jul 1994 14:44:24
*Fixes: (1) Remove debug messages
*
   
      Rev 1.1   07 Jul 1994 14:04:02
   Enhancements
   ------------
   
   1) Slight performance improvement
   2) Track printserver names added to General and Novell config screens
   
   Fixes
   -----
   
   1) Occasional hang after updating a version 4 unit twice too quickly fixed.
   
      Rev 1.0   07 Jul 1994  9:37:46
   Initial revision.
*	Original Version 2/2/94
*/

/* @(#)printset.h	1.4	7/5/95 */

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef NETWARE
typedef struct 
{
	IPXHeader IPXHdr;
	BYTE Data[576];
} IPXPkt;
#endif
#define LIFEEXPECTANCY	20		// 10 chances to respond once found valid

#include "pssumry.h"

#define 	AUTOIP			0
#define	OUR_IP_ADDR		1
#define	ACIA2				2
#define	ACIA3				3
#define	BAUD_DEC			4
#define	REMOTE			5
#define	FSERV_NAME		6
#define	PSERV_NAME 		7
#define	PRINTER_NUMBER	8
#define	EXACT_NUMBER	9
#define	SHARE_TIME		10
#define	PBUSY_TIME		11
#define	OUTPUT			12
#define	LANFLAG			13
#define	FTP_TIMEOUT		14
#define	ASERV_NAME		0x0f
#define	AZONE_NAME		0x10
#define	ENTITY1			0x11
#define	ENTITY2			0x12
#define	ENTITY3			0x13
#define	ENTITY4			0x14
#define	NOV_PNAME		0x15
#define	HWDESC			0x16
#define	PASSWORD			0x17
#define  SCANTIME			0x18
#define	SUBNET_MASK		29

#define STATUSSTRING	0xf4
#define	PRINTERSTRING	0xf6
#define	VENDOR			0xf7
#define	NIC				0xf8
#define	PROTOCOLS		0xf9
#define	HWDESC1			0xfa
#define  VERSION			0xfb
#define	HWTYPE			0xfc
#define	PRINTING			0xfd
#define	PSTATUS			0xfe

/*
*hardflag:	ds	1	; Hardware flags - bit set if active
*				; D7 = Serial
*				; D6 = Novell
*				; D5 = TCP/IP
*				; D4 = NetBeui
*				; D3 = LanManager
*				; D2 = Apple
*				; D1 = LAT
*				; D0 = DLC
*/

/*
*	type definition for possible networks installed
*/

#define N_NONE	0
#define N_IPX	1
#define N_LAN	2
#define N_ET	3



#ifdef NETWARE
#ifdef NWWIN
int __far NetworkInitialize(void);
int __far __pascal	IPXInitialize( DWORD __far *IPXTaskID, WORD maxECBs, WORD maxPacketSize );
void __far __pascal	IPXListenForPacket( DWORD IPXTaskID, ECB __far *eventControlBlock );
int __far __pascal	IPXOpenSocket( DWORD IPXTaskID, WORD __far *socketNumber, BYTE socketType );
void __far __pascal	IPXRelinquishControl(void);
void __far __pascal	IPXSendPacket(DWORD IPXTaskID, ECB __far *eventControlBlock );
int __far __pascal	IPXSPXDeinit( DWORD IPXTaskID );
void __far __pascal	IPXCloseSocket(DWORD IPXTaskID, WORD socketNumber);
// void IPXGetInternetworkAddress(DWORD IPXTaskID, BYTE __far *MyIPXAddress );

#define IPXINITIALIZE() IPXInitialize(&IPXTaskID,10,576)
#define IPXLISTENFORPACKET(x) IPXListenForPacket(IPXTaskID,x)
#define IPXOPENSOCKET(x,y) IPXOpenSocket(IPXTaskID,(x),(y))
#define IPXRELINQUISHCONTROL() IPXRelinquishControl()
#define IPXSENDPACKET(x) IPXSendPacket(IPXTaskID,x)
#define IPXSPXDEINIT() IPXSPXDeinit(IPXTaskID)
#define IPXCLOSESOCKET(x) IPXCloseSocket(IPXTaskID,x)
#define IPXGETINTERNETWORKADDRESS(x) IPXGetInternetworkAddress(IPXTaskID, x)


#else

// ***** DOS FUNCTION PROTOTYPES ******

int __far NetworkInitialize(void);
BYTE cdecl	IPXInitialize( void );
void IPXListenForPacket(  ECB __far *eventControlBlock );
int cdecl IPXOpenSocket( BYTE __far *socketNumber, BYTE socketType );
void cdecl IPXRelinquishControl(void);
void IPXSendPacket( ECB __far *eventControlBlock );
void cdecl IPXCloseSocket( WORD socketNumber);
// void IPXGetInternetworkAddress(BYTE __far *MyIPXAddress );

#define IPXINITIALIZE() IPXInitialize()
#define IPXLISTENFORPACKET(x) IPXListenForPacket(x)
#define IPXOPENSOCKET(x,y) IPXOpenSocket( (x),(y) )
#define IPXRELINQUISHCONTROL() IPXRelinquishControl()
#define IPXSENDPACKET(x) IPXSendPacket(x)
#define IPXSPXDEINIT() 
#define IPXCLOSESOCKET(x) IPXCloseSocket(x)
#define IPXGETINTERNETWORKADDRESS(x) IPXGetInternetworkAddress(x)

#endif
#endif //NETWARE

#ifdef __cplusplus
}
#endif

