/*
* FILE     : psdetail.c
* CREATED  : Tuesday, 17/5/1994
* AUTHOR   : Phil Beecher
* OWNER    : (C) ITC Ltd 1994
* SYSTEM   : Ansi C
* CONTENT  : the platform independent parts of the detail handler 
*          : 
* $Log:   C:/itc/printset/zinc/new/psdetail.c_v  $
*
*   Rev 1.2   14 Jul 1994 11:22:42
*First Release of pset and wpset for version 4 printservers
*
*
 * 
 *    Rev 1.1   07 Jul 1994 14:03:56
 * Enhancements
 * ------------
 * 
 * 1) Slight performance improvement
 * 2) Track printserver names added to General and Novell config screens
 * 
 * Fixes
 * -----
 * 
 * 1) Occasional hang after updating a version 4 unit twice too quickly fixed.
 * 
 *    Rev 1.0   07 Jul 1994  9:37:42
 * Initial revision.
*
*/

#if defined(DOS)
	#define NWDOS
#elif defined(WIN)
#define NWWIN
#define HANDLE unsigned char
#define FAR __far
#define PASCAL pascal
#define DWORD unsigned long
#define BOOL unsigned int

#include <nwcaldef.h>
#include <nwalias.h>
#include <npcalls.h>
#endif

static char sccsid[]="@(#)psdetail.c	1.7 7/18/95 ITC";

#ifdef NETWARE
#include <nwipxspx.h>
#include <nwcalls.h>
#endif

#ifdef APPLETALK
#include "AppleTalk.h"
#endif

#include <stdio.h>
#include <time.h>
#ifdef DOS
#include <dos.h>
#endif
#include <memory.h>
#include <ctype.h>
#include <string.h>

#include "printset.h"

static void DecryptPassword();
static void EncryptPassword();
#define ENC_KEY 0xa9

typedef struct br_t
{
	BYTE acia2;
	BYTE acia3;
	unsigned int br;
} BRS;

static BRS BaudRates[9] = 
{
	{0x04,0x0e,150},
	{0x04,0x0d,300},
	{0x04,0x0c,600},
	{0x04,0x0b,1200},
	{0x04,0x0a,2400},
	{0x04,0x09,4800},
	{0x04,0x08,9600},
	{0x04,0x01,19200},
	{0x04,0x00,38400}
};

/*
* $name$
*        SetDetailContents
* $paths$
*        functions\C
*        subsystems\
* $1$
* MODULE   : $./MDL$
* C SYNTAX : int SetDetailContents( psdetailinfo *ps, BYTE *buf )
* ENTRY    :
* EXIT     :
* TESTED   :
* CALLS    :
* RESOURCES:
* CONTENT  :
* $end$
*/
int SetDetailContents(ps, bp)
	PSDetailInfo *ps;
	BYTE *bp;
{
	int len, i;
	BYTE *bufstart;



	bufstart = bp;

	ps->BaudDec = BaudRates[ps->BRIndex].br;
	ps->Acia2 = BaudRates[ps->BRIndex].acia2;
	ps->Acia3 = BaudRates[ps->BRIndex].acia3;

	bcopy("HBM\2", bp, 4);
	bp += 4;
		
	*bp++ = AUTOIP; *bp++ = 1; *bp++ = ps->AutoIP? 0:0xff;
	*bp++ = OUR_IP_ADDR; *bp++ = 4; 
	for(i=0;i<4;i++)
		*bp++ = ps->IPAddr[i];
	 
	*bp++ = SUBNET_MASK; *bp++ = 4;
	for(i=0;i<4;i++)
		*bp++ = ps->SubnetMask[i];

	*bp++ = ACIA2; *bp++ = 1; *bp++ = ps->Acia2;
	
	*bp++ = ACIA3; *bp++ = 1; *bp++ = ps->Acia3;
	*bp++ = BAUD_DEC; *bp++ = 2;memcpy( bp, &ps->BaudDec, 2); bp+=2;
	*bp++ = REMOTE; *bp++ = 1;
	
	switch( ps->Remote )
	{
		case 0:
		*bp++ = 0x80;
		break;
		
		case 1:
		*bp++ = 0xff;
		break;
		
		case 2:
		default:
		*bp++ = 0x00;
		break;
	
	}
	*bp++ = FSERV_NAME;
	*bp++ = len = strlen( ps->FSName ) + 1;
	memcpy( bp, ps->FSName, len );
	bp += len;
	*bp++ = PSERV_NAME;
	*bp++ = len = strlen( ps->PSName ) + 1;
	memcpy( bp, ps->PSName, len );
	bp += len;

	*bp++ = PRINTER_NUMBER; *bp++ = 1; *bp++ = ps->Printer;
	*bp++ = EXACT_NUMBER; *bp++ = 1; *bp++ = !ps->Hunting;
	*bp++ = SHARE_TIME; *bp++ = 1; *bp++ = ps->ShareTime;
	*bp++ = PBUSY_TIME; *bp++ = 1; *bp++ = ps->BusyTime;
	*bp++ = OUTPUT; *bp++ = 1; *bp++ = ps->Output;
	*bp++ = SCANTIME; *bp++ = 1; *bp++ = ps->ScanTime;

	*bp++ = ASERV_NAME; 
	*bp++ = len = strlen( ps->ATPSName ) + 1;
	memcpy( bp, ps->ATPSName, len );
	bp += len;

	*bp++ = AZONE_NAME; 
	*bp++ = len = strlen( ps->ATZone ) + 1;
	memcpy( bp, ps->ATZone, len );
	bp += len;

	*bp++ = ENTITY1;
	*bp++ = len = strlen( ps->ATEntity[0] ) + 1;
	memcpy( bp, ps->ATEntity[0], len );
	bp += len;

	*bp++ = ENTITY2;
	*bp++ = len = strlen( ps->ATEntity[1] ) + 1;
	memcpy( bp, ps->ATEntity[1], len );
	bp += len;

	*bp++ = ENTITY3;
	*bp++ = len = strlen( ps->ATEntity[2] ) + 1;
	memcpy( bp, ps->ATEntity[2], len );
	bp += len;

	*bp++ = ENTITY4;
	*bp++ = len = strlen( ps->ATEntity[3] ) + 1;
	memcpy( bp, ps->ATEntity[3], len );
	bp += len;

	*bp++ = NOV_PNAME;
	*bp++ = len = strlen( ps->NWPSName ) + 1;
	memcpy( bp, ps->NWPSName, len );
	bp += len;
	
	*bp++ = PASSWORD;
	*bp++ = 32;
	EncryptPassword( bp, (unsigned char *) ps->NWPassword, 32 );
	bp += 32;

	len = bp - bufstart;

	return len;
}

/*
* $name$
*        GetDetailContents
* $paths$
*        functions\C
*        subsystems\
* $1$
* MODULE   : $./MDL$
* C SYNTAX : int GetDetailContents( PSDetailInfo __far *ps, BYTE *bp, int len )
* ENTRY    :
* EXIT     :
* TESTED   :
* CALLS    :
* RESOURCES:
* CONTENT  :extract from bp for length len into ps
* $end$
*/

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

int GetDetailContents(ps, bp, len)
	PSDetailInfo *ps;
	BYTE *bp;
	short len;
{
	short Offset;			
	unsigned char CopyLen;	
	short i;
	int NWName = FALSE, ATName = FALSE;
	int AutoIPDone = FALSE;
	

	strcpy( ps->Version, "-----" );
	ps->NWNameReceived = FALSE;
	ps->HWReceived = FALSE;
	ps->NodeReceived = FALSE;
	ps->StatusStringReceived = FALSE;

	ps->ScanTime = 0;
	
#ifdef VERBOSE
	sprintf( ps->PSName, "length = %02x\n", (int) len );
#endif
	for(Offset=0;/* (Offset<len) */ ; )
	{
		switch( *bp++ )
		{
			case PSERV_NAME:
			CopyLen = *bp;
			if( CopyLen > 48 )
				CopyLen = 48;
			strncpy(ps->PSName, (char *)(bp+1), CopyLen);
			if( !NWName )
				strncpy(ps->NWPSName, (char *)(bp+1), CopyLen);
			if( !ATName )
				strncpy(ps->ATPSName, (char *)(bp+1), CopyLen);

			break;

			case FSERV_NAME:
			CopyLen = *bp;
			if( CopyLen > 48 )
				CopyLen = 48;
			strncpy(ps->FSName, (char *)(bp+1), CopyLen);
			break;

			case ENTITY1:
			CopyLen = *bp;
			if( CopyLen > 32 )
				CopyLen = 32;
			strncpy(ps->ATEntity[0], (char *)(bp+1), CopyLen);
			break;

			case ENTITY2:
			CopyLen = *bp;
			if( CopyLen > 32 )
				CopyLen = 32;
			strncpy(ps->ATEntity[1], (char *)(bp+1), CopyLen);
			break;

			case ENTITY3:
			CopyLen = *bp;
			if( CopyLen > 32 )
				CopyLen = 32;
			strncpy(ps->ATEntity[2], (char *)(bp+1), CopyLen);
			break;

			case ENTITY4:
			CopyLen = *bp;
			if( CopyLen > 32 )
				CopyLen = 32;
			strncpy(ps->ATEntity[3], (char *)(bp+1), CopyLen);
			break;

			case AZONE_NAME:
			CopyLen = *bp;
			if( CopyLen > 48 )
				CopyLen = 48;
			strncpy(ps->ATZone, (char *)(bp+1), CopyLen);
			break;


			case NOV_PNAME:
			CopyLen = *bp;
			if( CopyLen > 48 )
				CopyLen = 48;
			strncpy(ps->NWPSName, (char *)(bp+1), CopyLen);
			NWName = TRUE;
			ps->NWNameReceived = TRUE;
			break;

			case ASERV_NAME:
			CopyLen = *bp;
			if( CopyLen > 48 )
				CopyLen = 48;
			strncpy(ps->ATPSName, (char *)(bp+1), CopyLen);
			ATName = TRUE;
			break;

			case PRINTERSTRING:
			CopyLen = *bp;
			if( CopyLen > 80 )
				CopyLen = 80;
			strncpy(ps->PrinterString, (char *)(bp+1), CopyLen);
			break;

			case STATUSSTRING:
			if(*bp>1)
			{
				CopyLen = *bp;
				if(CopyLen > sizeof(ps->StatusString))
					CopyLen=sizeof(ps->StatusString);
				strncpy(ps->StatusString, (char *)(bp+1), CopyLen);
				ps->StatusStringReceived=TRUE;
			}
			break;

			case PASSWORD:
			CopyLen = *bp;
			if( CopyLen > 32 )
				CopyLen = 32;
			DecryptPassword( (unsigned char *) ps->NWPassword, (BYTE *)(bp+1), CopyLen );
			break;

			case VENDOR:
			CopyLen = *bp;
			memcpy( ps->Node, (BYTE *)(bp+1), CopyLen );
			break;

			case NIC:
			CopyLen = *bp;
			memcpy( &ps->Node[3], (BYTE *)(bp+1), CopyLen );
			ps->NodeReceived = TRUE;
			break;

			case HWDESC:
			case HWDESC1:
			CopyLen = *bp;
			if( CopyLen > 48 )
				CopyLen = 48;
			strncpy(ps->HardwareDescription, (char *)(bp+1), CopyLen);
			ps->HWReceived = TRUE;
			break;

			case AUTOIP:
			if( AutoIPDone )
				return Offset;
			
			AutoIPDone = TRUE;
			CopyLen = *bp;
				
				
			ps->AutoIP = bp[1]? 0:1;
			
			for( i=0; i < 6; i++ )
				ps->Node[i] = bp[1+i];
			
			break;

			case OUR_IP_ADDR:
			memcpy( ps->IPAddr,(char*)(bp+1),4);
			break;

			case SUBNET_MASK:
			memcpy(ps->SubnetMask,(char*)(bp+1),4);
			break;

			case ACIA2: ps->Acia2 = bp[1]; break;

			case ACIA3: ps->Acia3 = bp[1]; break;

			case BAUD_DEC:
			CopyLen = *bp;
			memcpy( &ps->BaudDec, bp+1, CopyLen );
			for(i = 0; i< 9;i++)
			{
				if( ps->BaudDec  == BaudRates[i].br )
					ps->BRIndex = i;
			}
         break;

			case REMOTE:
			ps->Remote=bp[1];
			switch (ps->Remote)
			{
				case 0x80:
				ps->Remote = 0;
				break;
				
				case 0xff:
				ps->Remote = 1;
				break;
				
				case 0x00:
				ps->Remote = 2;
				break;
			}
			break;

			case PROTOCOLS: ps->Protocols = bp[1]; break;

			case SCANTIME:	ps->ScanTime = bp[1]; break;

			case PRINTER_NUMBER: ps->Printer=bp[1]; break;

			case EXACT_NUMBER: ps->Hunting=!bp[1]; break;

			case SHARE_TIME: ps->ShareTime=bp[1]; break;

			case PBUSY_TIME: ps->BusyTime=bp[1]; break;

			case OUTPUT: ps->Output=bp[1]; break;

			case LANFLAG: ps->LanFlag=bp[1]; break;

			case FTP_TIMEOUT: ps->FTP_Timeout=bp[1]; break;

			case HWTYPE: ps->HWType=bp[1]; break;

			case PRINTING: ps->Printing=bp[1]; break;

			case PSTATUS:
			ps->PStatus=bp[1];
			return Offset;
			break;

			case VERSION:
			CopyLen = *bp;
			if( CopyLen > 5 )
				CopyLen = 5;
			strncpy(ps->Version, (char *)bp+1, CopyLen);
			break;

			default:
			break;
		}

		Offset+=*bp+1;
		bp+=*bp+1;
	}
	return len;
}

static void EncryptPassword(d, s, len)
	BYTE *d;
	BYTE *s;
	int len;
{
	int i;
	int temp = 0xa9;
	for( i = 0; i< len; i++ )
	{
		d[i] = s[i]^temp;
		temp = d[i];
	}
	d[len] = '\0';

}
static void DecryptPassword(d, s, len)
	BYTE *d;
	BYTE *s;
	int len;
{
	int i;
	int temp = 0xa9;
	for( i = 0; i< len; i++ )
	{
		d[i] = s[i]^temp;
		temp = s[i];
	}
}

