/*
* FILE     : pssumry.h
* CREATED  : Thursday, 31/3/1994
* AUTHOR   : Phil Beecher
* OWNER    : (C) Ringdale Ltd 1994
* SYSTEM   : Ansi C
* CONTENT  : 
*          : 
* $Log:   C:/itc/printset/zinc/new/pssumry.h_v  $
*
*   Rev 1.3   14 Jul 1994 11:22:46
*First Release of pset and wpset for version 4 printservers
*
*
*
*   Rev 1.2   07 Jul 1994 14:44:24
*Fixes: (1) Remove debug messages
*
   
      Rev 1.1   07 Jul 1994 14:04:02
   Enhancements
   ------------
   
   1) Slight performance improvement
   2) Track printserver names added to General and Novell config screens
   
   Fixes
   -----
   
   1) Occasional hang after updating a version 4 unit twice too quickly fixed.
   
      Rev 1.0   07 Jul 1994  9:37:44
   Initial revision.
*
*/

/* @(#)pssumry.h	1.4	7/5/95 */

#ifndef PSSUMRY_H_INCLUDED
#define PSSUMRY_H_INCLUDED


#include <sys/types.h>
#include <netinet/in.h>

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef BYTE
# define BYTE unsigned char
#endif
#ifndef WORD
# define WORD unsigned int
#endif

typedef struct
{
	struct in_addr Address;
	BYTE AutoIP;
	BYTE IPAddr[4];
	BYTE SubnetMask[4];
	BYTE Acia2;
	BYTE Acia3;
	BYTE Baud;
	BYTE Hunting;
	BYTE Output;
	BYTE Printer;
	BYTE ShareTime;
	BYTE BusyTime;
	BYTE Remote;
	BYTE HWType;
	BYTE PStatus;
	BYTE Printing;
	BYTE LanFlag;
	BYTE FTP_Timeout;
	unsigned int BaudDec;
	int  BRIndex;
	char PSName[49];
	char FSName[49];
	char BaudRateStr[6];
	char IPAddrStr[16];
	char Version[6];
	BYTE Node[6];
	char ATPSName[49];
	char ATZone[49];
	char ATEntity[4][33];
	char NWPSName[49];
	int NWNameReceived;
	char NWPassword[33];
	char HardwareDescription[48];
	int HWReceived;
	BYTE ScanTime;
	BYTE Protocols;
	BYTE NodeReceived;
	char PrinterString[80];
	char StatusString[40];
	BYTE StatusStringReceived;
} PSDetailInfo;

typedef struct
{
	BYTE Hardware;
	BYTE Dialog;
	char  *Name;
} HardwareSummaryInfo;

#define TOKENRING 0x40
#define NOVELL 0x20

#define DIALOG1 0x01
#define DIALOG2	0x02
#define DIALOG3	0x03
#define DIALOGN1	(DIALOG1 | NOVELL)
#define DIALOGN2	(DIALOG2 | NOVELL)
#define DIALOGN3	(DIALOG3 | NOVELL)

#define VISIBLE 0x01
#define LOCAL 	0x02

#ifdef __cplusplus
}
#endif

#endif

