/* @(#)sparkle.h	1.8	7/18/95 */

#ifndef	SPARKLE_H_INCLUDED
#define	SPARKLE_H_INCLUDED

#include <curses.h>
#include "pssumry.h"

#define	SPARKLE_REFRESH	6	/* refresh every 6 seconds */

#define	offsetof(s,m)	(size_t)((char *)&(((s *)0)->m)-(char *)0)

extern char *sys_errlist[];


/* Data types */

struct interface
{
	PSDetailInfo	ps;	/* interface details */
	int		alive;	/* drops from list after n refreshes */
	struct in_addr	addr;	/* IP address */

	struct interface *next;
	struct interface *prev;
};


/* main.c */

extern	char			scratch_buffer[];
extern	int			current_row;


/* udp.c */

int	udp_init		();
void	AcquirePSList		();
int	SendDetailPacket	();


/* psdetail.c */

int	SetDetailContents	();
int	GetDetailContents	();


/* utils.c */

void	timer_state		();
void	centre			();
char	*strupr			();
void	catch_signals		();
void	fatal			();


/* display.c */

void	display_init		();
void	display_shutdown	();
void	display_list		();
void	highlight_row		();


/* list.c */

struct interface *add_interface_to_list		();
struct interface *find_interface_in_list	();
void		  update_list			();

extern	struct interface	*SummaryList;
extern	struct interface	*SortedList[];
extern	int			NumberOfSummaries;


/* interface.c */

void	display_details		();


/* auto.c */

/* Only enable Auto IP if we're a Sun, until we figure out a more
   platform-independent way of doing it. */

/* #ifdef HAVE_NET_IF_ARP_H */
#ifdef sun
#define SPARKLE_AUTO_IP
void	auto_ip			();
#endif


extern	WINDOW			*wMain, *wList;

#endif /* SPARKLE_H_INCLUDED */

